#use openstructure to run
#analyze rasmot output

# PDB-Mirror in 
LOCALMIRROR="/home/vielplatz/pdb_all/"
# for newer/renamed/different pdbfiles:
ADDITIONALREPOS="/home/beat/cuniasse2nd/missingpdbfiles/"

# INCLUDE ALL FOUND PDBCHAINS (True)
samePDB_and_sameGROUP_MULTIHIT_ENABLED=True

# ACCEPT ALL PDBCODES
ACCEPTALL=True

#libraries
import os
import os
import shutil
import os


remove=raw_input("REMOVE ALL LOG and RESULTFILES? (N)/Y")
if remove.upper() == "Y":
    os.system("rm group_props.csv  logfileallok.csv  logfile.csv  logfileFATAL.csv  logfileknown.csv  logfilemetallated.csv  logfilenopub.csv  withlit.csv log.log")

if ACCEPTALL==False:
 accepted_pdb_codes=[]
 for each in open("95.ls","r"):
    accepted_pdb_codes.append(each.strip().lower())

else:
 accepted_pdb_codes=[""]

startlist="startlist.pdbcode.metallated.ls"
q=0
sl=open(startlist,"r")

a=[]

for line in sl:
    b=line.split()
    for each in b:
       a.append(each.upper())

sl=a

prop=open("group_props.csv","w")

log = open("log.log","a")
log.write("START---------------------------START-----------------------------------START\n")

s={}
#Superseeded Files
s.update({"1M50":"3ENI"})
s.update({"3KS1":"3MWO"})
s.update({"3E4X":"3GOR"})
s.update({"3H4U":"3HPA"})
s.update({"3LWY":"3N2C"})
s.update({"2JCI":"2XD5"})
s.update({"3L90":"3MI3"})
s.update({"2R8C":"3MKV"})
s.update({"2FRN":"3K6R"})
s.update({"2ZDW":"3A4Y"})
s.update({"2ZDD":"3IE0"})
s.update({"3ETK":"3ICJ"})
s.update({"4BCL":"3E0J"})
s.update({"2ILB":"3H50"})
s.update({"1WX3":"2ZMX"})
s.update({"3GNH":"3MTW"})

GLUmax=7.5380005244    
ASPmax=6.2361350131    
HISmax=9.2529062594


print "\n\nSTARTING... \n"



notfound={}
metalhit=0
nohit=0
asehit=0
realhit=0
userinteraction=0
literature=[]


def header(pdbcode):
#Extracts DOI, NAME and DATE from PDB-Header
    global file
    f = open (file)
    DOI=""
    for each in f:
        proceed=False
        line=each.strip()
        if each[:6]=="HEADER":
            NAME=line[10:50]
            NAME=NAME.replace("(","/")
            NAME=NAME.replace(",","/")
            NAME=NAME.split()
            NAME=NAME[0]
            DATE=line[50:60]
        if line[:4]!="ATOM" and line[:6]!="HETATM":
          if "JRNL" in line:
              if "DOI" in line:
                  DOI=line.split()[2]

    return DOI, NAME, DATE


def parsestamps_dat(stamps_dat):
#Parsing stamps.dat
    class USED(Exception):
       def __init__(self, value):
          self.value = value
       def __str__(self):
          return repr(self.value)


    verbose=False
    usedpdbcodes=[]
    file = open(stamps_dat, "r")
    a=[]
    for line in file:
        if samePDB_and_sameGROUP_MULTIHIT_ENABLED==True:
            usedpdbcodes=[]
        b=[]
        line=line.strip()
        words=line.split()
        if len(words)>15:
          try:
            b.append(words[0][3:7])   #pdb_code
            if b[0] in usedpdbcodes:
              raise USED(b[0])  
            b.append(words[0][7])     #pdb_chain
            b.append(words[0][9:11])  #pdb_domain
            b.append(words[1])   #Size
            b.append(words[3])   #rmsd
            b.append(words[7])   #AA1
            b.append(int(words[8]))
            b.append(words[11])  #AA2
            b.append(int(words[12]))
            b.append(words[15])  #AA3
            b.append(int(words[16]))
          except USED as q:
            del q
            b=[]
            pass
          except ValueError:
            log.write("WARNING: FILE CAUSED ERROR> "+ line+ " >>>EXCLUDED FROM SCAN\n")
            b=[]
        if len(b)>0:
            usedpdbcodes.append(b[0])
            a.append(b)
    return a

def getpos(pdbcode, resultlist, kette):
# Isolates the chain "kette" with PDBCODE "pdbcode" from list "resultlist"
    verbose=True
    a=[]
    for each in resultlist:
        if pdbcode in each[0]:
            a.append(each)
            if verbose: print each
    for b in a:
        if b[1]==kette:
            if verbose: "Found CHAIN!"
            return b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8], b[9], b[10]
    print "FAILED trying to isolate chain!", kette
    raw_input("getpos failed")

def checkatoms(atomlist):
# Checks every atom in "atomlist" for beeing transitionmetals
    global notes
    
    metals=[]
     
    for atom in atomlist:
    
        if not atom.element in ["H","C", "O", "N", "P", "S", "SE", "F", "CL", "BR", "I", "D"]:
              if atom.element in ["K", "NA", "MG", "CA"]:
                      p = geom.Vec3(pos)
                      q = geom.Vec3(atom.pos)
                      d = geom.Distance(p,q)
                      notes.append(atom.element+"-"+str(atom.GetIndex()) + "=" + str(d))
              else:
                    metals.append(atom)

    if metals:
        return metals
    return False 

def copyto(pdbcode,trg, attr="",writetcl=False):
# Seperates PDB files in categories (subfolders)

    global target
    if len(trg) == 1:

        target=outputdir + target + "." + str(attr) +"/"

        while not os.path.isdir(target):
            os.makedirs(target)

        os.system("mv " + outputdir + "hit/*" + pdbcode + "* " + target ) 
        return
     
    target=trg

    if target=="apo":
        target="apo"
    if target=="mc":
        target="metal.containing" + attr
    elif target=="hit":
        target="hit"+attr
    elif target=="nf":
        target="notfound" + attr
    elif target=="s":
        target="souspicious." + attr
    else:
        return False

    target=outputdir + target+"/"
    
    while not os.path.isdir(target):
      os.makedirs(target)

    try:
        shutil.copyfile(file, target + pdbcode + ".orig.pdb")
    except:
        global userinteraction
        userinteraction+=1
        #print NOT FOUND:",pdbcode
        os.system("echo \" "+ pdbcode + "\" >> pdbfilenotfound.err.txt")
    filename = "pdb" + pdbcode + Chain + "_" + Domain
     
    shutil.copyfile(resultsdir + filename + ".pdb", target + filename + ".pdb")
    if writetcl:
      vmdscripter(target + filename + ".tcl")
    
    #Optional Implement:
    #Copy following things: pymol srcripts, motif, result

class ProgressError(Exception):
#Error Handler
     def __init__(self, value):
         self.value = value
     def __str__(self):
         return str(self.value)

folders=[]
#Adjust range
for x in range(1,61):
        folders.append("m" + str(x))


#Initialising vars for actual work
hits=0
realhit=0
metallated=0
pdbcode_continue=False
goforit=True
test=doilink=pdbcode=Chain=Domain=Size=rmsd=X=XN=H1=H1N=H2=H2N=NAME=DATE=""
for path in folders:
    group=path
    path=path.strip()
    path += "/"
    outputdir="./results/" + path                          
    resultsdir="./" + path + "/results/"
    resultsdir="./" + path + "/results/"
    list={}
    resultlist=parsestamps_dat("./" + path + "/stamps.dat")
    prop.write(group + ";" + str(len(list)))
    print group, "single#:", len(list)
    written=[]
    for maurus in resultlist:
        kette=maurus[1]
        pdbcode=maurus[0]
        pdbcode=str(pdbcode)

        try:
               notes=[]
               if pdbcode.upper() in sl:
                  raise ProgressError("known")
               if pdbcode.upper() in s:
                  raise ProgressError("superseeded")
               try:
                 del file
               except:
                 pass
               test=doilink=Chain=Domain=Size=rmsd=X=XN=H1=H1N=H2=H2N=NAME=DATE=""
               del test,doilink,Chain,Domain,Size,rmsd,X,XN,H1,H1N,H2,H2N,NAME,DATE
               pdbcode=pdbcode.strip()

               for each in ["loop_to_break"]:
                    try:                    
                     Chain,Domain,Size,rmsd,X,XN,H1,H1N,H2,H2N= getpos(pdbcode,resultlist,kette)
                    except TypeError:
                     print pdbcode, kette
                     raw_input("")
                    if pdbcode.upper() in s:
                        pdbcode=s[pdbcode.upper()].lower()

                    try:
                        pathtopdbmirror=LOCALMIRROR
                        file = pathtopdbmirror + "pdb" + pdbcode + ".ent"
                        if not os.path.exists(file):
                            raise KeyError
                        protein=io.LoadPDB(file, fault_tolerant=True)
                    except:
                        try:
                            pathtopdbmirror=ADDITIONALREPOS
                            file = pathtopdbmirror + "pdb" + pdbcode + ".ent"
                            if not os.path.exists(file):
                                raise KeyError
                            protein=io.LoadPDB(file, fault_tolerant=True)
                        except:
                            try:
                                file = pathtopdbmirror + pdbcode.upper() + ".pdb"
                                if not os.path.exists(file):
                                    raise KeyError
                                protein=io.LoadPDB(file, fault_tolerant=True)
                            except:
                                notfound.update({pdbcode:pdbcode})
                                print "no access to file!", pdbcode
                                log.write("no access to file " + pdbcode + "\n")
                                raw_input("troeble: " + file)
                                raise ProgressError("no access to file")


                    DOI,NAME,DATE=header(pdbcode)

                    metals=[]



                    for residue in [H1N,H2N,XN]:
                        if residue==XN:
                            minmetaldist=GLUmax
                        else:
                            minmetaldist=HISmax
                        print file
                        print pdbcode, Chain, residue
                        try:
                          pos = protein.FindAtom(Chain, residue, "CA").pos
                        except:
                          print "\n\nFATAL! ERROR ACCESS TO PDB FILE\n\n"
                          for atom in protein.atoms:
                              print atom,
                          print "\n\nFATAL! ERROR ACCESS TO PDB FILE\n\n"
                          raise ProgressError("FATAL")
                        atomlist= protein.FindWithin(pos, minmetaldist) 

                        metal = checkatoms(atomlist)

                        if metal:
                            for each in metal:
                                metalhit+=1
                                p = geom.Vec3(pos)
                                q = geom.Vec3(each.pos)
                                d = geom.Distance(p,q)
                                metals.append(each.element + "-d=" + str(d))

                    if len(metals)!=0:
                        list = str(len(metals)) + " "
                        for each in metals:
                            list += each + ":"   
                        metallated+=1 
                        raise ProgressError("metallfound " + list[:-1])

                    else:
                        code=""
                        
                        for each in [pdbcode,Chain,Domain,Size,rmsd,X,XN,H1,H1N,H2,H2N]:
                            code+=";"+str(each)
                        
                        literature.append("http://dx.doi.org/"+str(DOI)+code+"$$$")

                    
                    if not DOI:
                        raise ProgressError("nopub")

                    raise ProgressError("allok")
          
        except ProgressError as test:
             if pdbcode in accepted_pdb_codes:
                acceptable = "True"
             else:
                acceptable = "False"

             if accepted_pdb_codes==[""]:
                acceptable = "NA"

             test=str(test)
             if test=="FATAL":
                 notes.append("FATAL")

             if test=="superseeded":
                accepatable="False"
                notes.append("superseeded")
                test="FATAL"

             if test=="known":
               notes.append("known")
               print "alreadyknown"
             elif DOI:
                doilink="http://dx.doi.org/" + DOI + ";"
             else:
                doilink=";"
             if not test == "noaccess" and test!="known":
                try:
                  a=[acceptable,test,pdbcode,group,doilink,Chain,Domain,Size,rmsd,X,XN,H1,H1N,H2,H2N,NAME,DATE,file]
                except:
                    try:
                      a=[acceptable,test,pdbcode,group,doilink,Chain,Domain,Size,rmsd,X,XN,H1,H1N,H2,H2N]
                    except:
                      a.append("exception;")
             else:
                a = [acceptable,test,pdbcode,group]
             
             for each in notes:
                a.append(each+";")
          
             l = test
             if "metallfound" in l:
                 l="metallated"
             
             for lf in ["",l]:
              f = open ("logfile" + lf + ".csv", "a")

              for each in a:
                f.write(str(each) + ";")

              f.write("\n")
              written.append(a)
              f.close()


    prop.write(";"+ str(metallated)+"\n")
    print group, "metallated: ", metallated
    metallated=0



#Visual Feedback
print "notfound", len(notfound)
for each in notfound:
    print each,
print 
print "nohit", nohit
print "asehit", asehit
print "realhit", realhit
print "userinteraction", userinteraction
print "metalhit", metalhit
print "literature", len(literature)

#Creating "withlit.csv" as files with DOI (so they have been published)
for each in literature:
    os.system("echo \"" + each + "\" >> withlit.csv")

log.write("END-----------------------------END---------------------------------------END\n")
log.close()
#Wait on user confirmation
raw_input("pressentertocontinue")
