# use openstructure to run

MAXwTOT=361
MINwTOT=0

"""
MAXwTOT=300
MINwTOT=240
"""

nodoublehits=False

dontdl=True

import os
os.system("rm FINISH.LOG")
import math
from optparse import OptionParser

#SETTINGi GLOBAL SETTINGS, READING PARAMETER AND INITIALIZING VARS. FIRST ERROR CATCHING MECHANISMS./

#Global Settings / Initialisations:
version="FINAL"
onefile=True
datei=""
lasthitolig=[]
lastoutput=[]
counter=0
headerarray=[]
valuearray=[]
uuidlist=[]

minimalpdbcounter=0

#Einheitsvektoren:
eX=geom.Vec3(1,0,0)
eY=geom.Vec3(0,1,0)
eZ=geom.Vec3(0,0,1)

#CATH
ext = ".cathdbinfo.xml"
path = "./cathdbinfo/"
FINAL = []
NOCATH = []

#SCOPing:
index_name=[]
index_cont=[]

#FindRelated
pdbmirror = "/home/vielplatz/pdb_all/pdb$$pdbcode$$.ent"

#Banned Files
SKIPPED=[]
atomliste=[]
BANLIST=["1cet.ent", "2r6n.ent", "2hlp.ent", "2bwx.ent", "1ldg.ent", "1qfu.ent", "1jrt.ent", "1cc5.ent"]
maxdis=3.01

#Options:
progress=True
getTitle=True
verbose=False
startmessage=False

class Error(Exception):
    """Base class for exceptions in this module."""
    pass

class WtotError(Exception):
     def __init__(self, value):
         self.value = value
     def __str__(self):
         return repr(self.value)

class GotHitError(Exception):
     def __init__(self, value):
         self.value = value
     def __str__(self):
         return repr(self.value)
        

#Parsing and Initializations /
def argparser():
 global args, datei, path, temp
 if len(args) != 3:
    if len(args)==0:
        args.append("/home/beat/Desktop/vmshare/vmd_tmp_darst/temp.csv")
        print "args appendesd"
    if len(args)==1 and (".csv" in args[0]):
        print "csv checked"
        temp = []
        pretemp = ""
        posttemp = ""
        x = -1
        csv = open (args[0], "r")
        for line in csv:
            words = line.split(";")
            if len(words)==1:
                words = line.split("\t")
            if x == -1:
                for x in range(0, len(words)):
                    if words[x] == "name":
                        break;
            else:
              if pretemp == posttemp:
                if "/home/vielplatz/pdb_all/pdb" in words[x]:
                    pretemp=""
                else:
                    pretemp = "/home/vielplatz/pdb_all/pdb"
                if ".ent" in words[x]:
                    posttemp=""
                else:
                    posttemp=".ent"
              if len(temp)==0:
                  temp.append(pretemp + words[x].strip() + posttemp)
              else:
                  if not temp[len(temp)-1] == (pretemp + words[x].strip() + posttemp):
                    temp.append(pretemp + words[x].strip() + posttemp)
        datei = ""
        print temp
        args.append("output.csv")
        path=""

    else:
        print "\n\nFatal: Need exact 3 Arguments! 1)ListName 2)OutputName 3)PathToList ('none' => none)"
        print "                                     or"
        print "\n\n                  1 Argument:    ListName.csv"

        import sys
        sys.exit()
 else:
    datei=args[0]
    if args[2]=="none":
        path=""
    else:
        path=args[2]

def parseoptions():
    #Optionparser /
    global args,  options
    parser = OptionParser()
    parser.add_option("-d", "--debug", dest="debugging", action="store_true", default=False, help="show ebug information")
    parser.add_option("--version", dest="version", action="store_true", default=False, help="show version information and quit")
    parser.add_option("-v", "--verbose", dest="verbose", action="store_true", default=False, help="verbose mode")
    parser.add_option("-p", "--progress-bar", dest="progressbar", action="store_true", default=False, help="show progress information")
    parser.add_option("--progress", dest="progress", action="store_true", default=False, help="show progress information")
    parser.add_option("-x", "--xyz-output", dest="xyzdata", action="store_true", default=False, help="additional output: xyz coordinates")
    parser.add_option("-n", "--normalize", dest="normalize", action="store_true", default=False, help="normalize all vectors")
    parser.add_option("-e", "--entity-filer", dest="pdbfiler", action="store_true", default=False, help="pdbfile with rotated coord")
    parser.add_option("--vmd", dest="vmdfiler", action="store_true", default=False, help="for every pdbfile written write a vmd and a script: CAUTION deletes all  *pdb *sh *tcl *_ in cwd!!!!")
    parser.add_option("-s", "--scop-fold", dest="scop", action="store_true", default=False, help="pdbfile with rotated coord")
    parser.add_option("--sFE", dest="selectFE", action="store_true", default=False, help="select only Iron as Metal, other metals are skipped")
    parser.add_option("--sZN", dest="selectZN", action="store_true", default=False, help="select only ZINK as Metal, other metals are skipped")
    parser.add_option("--sCU", dest="selectCU", action="store_true", default=False, help="select only COPPER as Metal, other metals are skipped")
    parser.add_option("--INCLUDEOLIGOMERS", dest="excludeOligomer", action="store_false", default=True, help="Include all hits, even from obvious oligomers")
    parser.add_option("-c", "--cath", dest="cathfiler", action="store_true", default=True, help="add CATH information") 
    parser.add_option("-f", "--fpocket", dest="fpocket", action="store_true", default=False, help="use f pocket to find gather information about the closest pocket and its volume (apprx).) Only accepted if VMDFiler and PDBFiler are enabled")
    parser.add_option("--splitb", dest="splitted", action="store_false", default=True, help="splitted")
    (options, args) = parser.parse_args()
    
    options.scop = False
    options.cathfiler = False
    options.pdbfiler = False
    options.vmdfiler = False
    options.fpocketer = False
    options.progressbar = True

#End of Initialization /
def dlCATHdbXML(pdbcode):
    if dontdl: die()
    pdbcode = pdbcode.lower()
    ext = ".cathdbinfo.xml"
    path = "./cathdbinfo/"
    if not os.path.isdir(path):
        os.makedirs(path)
    link="http://www.cathdb.info/pdb/" + pdbcode + "?view=xml"
    saveto=path + pdbcode + ext
    os.system("wget " + link + " -v -O " + saveto)
    if verbose:
        print "wget " + link + " -v -O " + saveto

def getTitle(pdbcode):
    pdbfile = pdbmirror.replace("$$pdbcode$$",pdbcode)
    title = ""
    if os.path.isfile(pdbfile):
         pdbfile = open(pdbmirror.replace("$$pdbcode$$",pdbcode),"r")
         for line in pdbfile:
             if "TITLE" in line:
                 title = title + line[10:].strip() 
    else:
        return "WARNING: NO PDB FILE IN LOCAL MIRROR"
    if len(title)==0:
        return "WARNING: NO TITLE INFORMATION IN PDB FILE"
    return title

def dlPDBmainHTML(pdbcode):
    if dontdl: die()
    pdbcode = pdbcode.lower()
    ext = ".PDB.org.main.html"
    path = os.getcwd()+"/pdborghtml/"
    if not os.path.isdir(path):
        os.makedirs(path)
    saveto = path + pdbcode + ext
    link="http://www.pdb.org/pdb/explore/explore.do?structureId=" + pdbcode 
    os.system("wget " + link +" -v -O " + saveto)
    if verbose:
        print "wget " + link + " -v -O " + saveto

def getCATHofChains(liste, chains=["all"]):
    if chains[0] != "all":
        filteredliste=[]
        for chain in chains:
            for entries in liste:
                if chain in entries[1]:
                    filteredliste.append(entries)
        return filteredliste
    else:
        return liste

def chopper(line):
    #Chopps a given Line if its a Link Very Instable (!)
    lc=line.find(">")
    if lc>10:
        uc=line.find("<",lc)
        if uc>0:
            temp = line[lc+1:uc]
            if temp[:1] == " ":
                temp = temp[1:]
            return temp
    if lc==-1:
        return line.strip()

def getCATH(pdbcode,chains=["all"]):
    #CATH ENTRY FINDER (CATHdb.info)
    verbose=True
    startmessage=True
    if startmessage:
         print "Started getCATH"
    ext = ".cathdbinfo.xml"
    path = os.getcwd() + "/cathdbinfo/"
    if not os.path.isfile(path + pdbcode + ext):
        dlCATHdbXML(pdbcode.strip())
    if not os.path.isfile(path + pdbcode  + ext):
        raise Exception("NoCath", "download has failed or no cath file available")
    
    file = open (path + pdbcode + ext, "r")    

    #Resetting Variables and Arrays
    liste = []
    domain_count=-1
    domain_code=""
    cathpdbq=False
    domains=-1
    chain_code=""
    domain_code=""
    cath_code=""
    i=0
    
    #Scan trough file line for line.
    for line in file:
        i+=1
        line = line.strip()
        if verbose: print "\t", i, "\t", line[:50]
        #trigger => turn off domain
        if "</cath_domain>" in line:
            domain_count -= 1
            liste.append([domains-domain_count,chain_code,domain_code,cath_code])
            domain_code="-1"
            if verbose: print "End Of Domain. Resetting Current Domain to -1"
        #trigger => turn on CATH mode
        if "cath_pdb_query" in line and not "/cath_pdb_query" in line:
            cathpdbq=True
            if verbose: print "Found CATH => starting cath mode on line ", i
        if cathpdbq:
            if "cath_domain_count=" in line:
                domain_count=int(line.split("\"")[1])
                domains=domain_count
                if verbose: print "Found ", domains, " Domains!"
            if abs(domain_count) > 0:
                if "chain_code" in line:
                    chain_code=line.split("\"")[1]
                if "domain_code" in line:
                    domain_code=line.split("\"")[1]
                    if verbose: print "Begin of Domain ", domain_code
                if "</cath_code>" in line:
                    cath_code=chopper(line)
            else:
                if verbose: print "No more domains left. Cancel file scan!"
                cathpdbq=False
    file.close()
    if verbose: print liste
    return getCATHofChains(liste, chains)

def FindSimililarPDBs(pdbcode,follow=False):
    if dontdl: die()
    global similarfiles
    #Similar Files Finder (PDB-related)
    if follow == False and len(similarfiles)>0:
        return similarfiles
    ext = ".PDB.org.main.html"
    path = os.getcwd() + "/pdborghtml/"
    verbose=False
    debug=False
    if startmessage:
        print "Similar Files Finder (PDB-related)"
        if follow: print "\n ==> DETECTING RELATED FILES <=="
    pdbfiles=[pdbcode.lower()]
    lines=[]
    lines.append(pdbcode.lower())
    for eachfile in pdbfiles:
        if verbose: print "Current file: ", eachfile
        htmlfile = path + pdbcode + ext
        relatedfiles = False
        if not os.path.isfile(htmlfile):
            dlPDBmainHTML(pdbcode)
        if not os.path.isfile(htmlfile): 
            print "ERROR: NO ACCESS TO RELATED PDB FILES"
            return ["ERROR: NO ACCESS TO RELATED PDB FILES"]
        sim = open(htmlfile,"r")
        for line in sim:
          if "Related PDB Entries" in line: 
              relatedfiles=True
              if verbose: print "Found Related PDBs!"
          if relatedfiles:
            if "href=\"/pdb/explore.do?structureId=" in line:
                if debug: print "", line
                line=line.strip()
                line=line.split(">")[1]
                line=line[0:4]
                if verbose: print line
                line = line.lower()
                if not line.isalnum():
                    print "ERROR: PARSING FAILED!!! VALUE MUST BE ALPHANUMBERIC > ", str(line)
                    print htmlfile
                    sys.exit()
                else:
                    if verbose: print line
                    lines.append(line)
                    if follow:
                        if not line in pdbfiles:
                            pdbfiles.append(line)
    if not follow: similarfiles = lines
    return lines

def LineNotExistent(line,array):
        if line in array:
            return False 
        return True

def LiesOnLine(find,List):
        for each in List:
            #print each, find
            if each in find:
                return List.index(each)
        return -1

def NotInBanList(pdbfile):
    #Check if a file must not be scanned. If so print a message.
    if os.path.isfile(pdbfile.strip()):
        for each in BANLIST:
            if each in pdbfile:
                print "WARNING: FILE SCAN CANCELLED: REASON LISTET IN BANLIST:>>", pdbfile
                print "MATCHES BANLIST ENTRY:>>", each
                SKIPPED.append(pdbfile)
                return False
            return True
        else:
            print "WARNING: FILE SCAN CANCELLED: FILE INEXISTENT:>>", pdbfile
            SKIPPED.append(str("INEXISTENT: " + pdbfile))

def getResolution(gRpdbfile):
    gRfile = open (gRpdbfile)
    gRpattern = "REMARK   2 RESOLUTION.  "
    gRback = ""
    for gRline in gRfile:
        if gRpattern in gRline:
            gRback = gRline
            break
    if gRback == "":
        return 0
    else:
        gRbacksplitted=gRback.split()
        return gRbacksplitted[3]

def findrelatedpdb(pdbfilename):
    #Similar Files Finder
     print "\n\n\n\n"
     print pdbfilename
     return FindSimililarPDBs(pdbcode,follow=False)

def winkler(rotateToXAxis, rotateToXZPlane):
    #####Rotating point P onto X-Axis. (#1, #2) /
    #####Then rotataing Q arround X-Axis, such that Q lies in XZ-Plane (#3)
    if options.debugging: print "\n\n", pdbfile.strip()
    eX=geom.Vec3(1,0,0)
    eY=geom.Vec3(0,1,0)
    eZ=geom.Vec3(0,0,1)  
    P=rotateToXAxis
    Q=rotateToXZPlane
    if options.debugging: print "P:",P
    if options.debugging: print "Q:",Q
    
    #1) Turning P into XY-Plane
    v=geom.Normalize(P)
    vxy0=geom.Vec3(v.x,v.y,0)
    wPXY=geom.Angle(vxy0,eX)
    if options.debugging: print math.degrees(wPXY)
    rotMat1a=geom.AxisRotation(eZ,wPXY)
    rotMat1b=geom.AxisRotation(eZ,-wPXY)
    if abs((rotMat1a*P).y)>= abs((rotMat1b*P).y):
      rotMat1=rotMat1b
    else:
      rotMat1=rotMat1a

    if options.debugging: print "P*M1 ", rotMat1*P

    #2) Turning P into XZ-Plane
    Ps=rotMat1*P
    vs=geom.Normalize(Ps)
    vxz0s=geom.Vec3(vs.x,vs.y,vs.z)
    wPsXZ=geom.Angle(vxz0s,eX)
    if options.debugging: print math.degrees(wPsXZ)
    rotMat2a=geom.AxisRotation(eY,wPsXZ)
    rotMat2b=geom.AxisRotation(eY,-wPsXZ)
    if abs((rotMat2a*Ps).z)>=abs((rotMat2b*Ps).z):
      rotMat2=rotMat2b
    else:
      rotMat2=rotMat2a

    if options.debugging: print "Ps*M2", rotMat2*Ps

    #3) Now going to Turn Point Q into XZ-Plane
    Qss=rotMat2*(rotMat1*Q)
    v=geom.Normalize(Qss)
    v0yz=geom.Vec3(0,v.y,v.z)
    wQXZ=geom.Angle(v0yz,eZ)
    if options.debugging: print math.degrees(wQXZ)
    rotMat3a=geom.AxisRotation(eX,wQXZ)
    rotMat3b=geom.AxisRotation(eX,-wQXZ)
    if abs((rotMat3a*Qss).y)>=abs((rotMat3b*Qss).y):
      rotMat3=rotMat3b
    else:
      rotMat3=rotMat3a
        
    return (rotMat1, rotMat2, rotMat3)

def distance(atom1, atom2): 
    return math.sqrt( math.pow(atom1[0]-atom2[0],2) + math.pow(atom1[1]-atom2[1],2) + math.pow(atom1[2]-atom2[2],2) )

def isSelMetal(atom):
    ###Determining if a atom is a metal of selection.
   if options.selectCU:
       if atom.element=="CU":
           return True
       return False
   if options.selectFE:
      if atom.element=="FE":
    ###If it is, return True, else False.
          return True
      return False
   if options.selectZN:
       if atom.element=="ZN":
           return True
       return False
    ###If not, just do a normal metal search.
   if atom.mass > 41 and metal.element!="SE" and metal.element!="BR" and metal.element!="KR" and metal.element!="I" and metal.element!="XE" and  metal.element!="AT" and metal.element!="RN" :
    return True
   else:
    return False

def isMetal(atom):
    ###Determining if a atom is a metal
    if atom.mass > 41 and metal.element!="SE" and metal.element!="BR" and metal.element!="KR" and metal.element!="I" and metal.element!="XE" and  metal.element!="AT" and metal.element!="RN" :
        return True
    else:
        return False

def findResInList(Res,List):
    ##Search for a Residue Res in a Array List. 
    ##If it is there, return the Index of it in List.
    ##Else return -1
    for atom in List:
        if atom.residue==Res:
            return List.index(atom)
    return -1

def printVector(v,element):
    ##Printing a xyz formatted file. => (Without header!!!)
    return element + "\t" + str(v.x) + "\t" + str(v.y) + "\t" + str(v.z) + "\n"

def getSCOP(pdbcode):
    SCOP=[]
    words=[]
    sign=[]
    if options.verbose:
        print find
    logfile = open ("dir.des.scop.txt_1.75","r")
    for line in logfile:
        if pdbcode in line:
            words = line.split()
            sign = words[2]
            if LineNotExistent(words[5][0]+","+sign,SCOP):
                SCOP.append(words[5][0]+","+sign)
    logfile.close()
    return SCOP

def FindSCOP(pdbcodes):
    Class=[]
    NoClass=[]
    for each in pdbcodes:
        tmpSCOP = getSCOP(each)
        if len(tmpSCOP) > 0:
            Class.append(tmpSCOP)
    return Class

def FindDetector(pdbcodes):
    Class=[]
    NoClass=[]
    for each in pdbcodes:
      try:  
        tmpCATH = getCATH(each)
        if len(tmpCATH) > 0:
            for every in tmpCATH:
                if every[3] != "":
                    Class.append(every)
                else:
                    NoClass.append(every)
      except:
        print "NoCathDownload!"
        print "ADD INFORMATION TO CATH.LOG"
        os.system("echo \"DOWNLOAD FAILED " + pdbfile.strip() +"\" >> CATH.LOG")
        
    return Class, NoClass

def scopfiler(pdbcode):
    order = 0
    Class =  FindSCOP([pdbcode])
    if len(Class)>0:
        return order, Class
    else:
        order += 1

    Class = FindSCOP(FindSimililarPDBs(pdbcode,follow=False))
    if len(Class)>0:
        return order, Class
    else:
        order += 1

    Class = FindSCOP(FindSimililarPDBs(pdbcode,follow=True))
    if len(Class)>0:
        return order, Class
    
    return order, []

def cathfiler(pdbcode):
    order = 0
    Class, NoClass =  FindDetector([pdbcode])
    if len(Class)>0:
        return order, Class
    else:
        order += 1

    Class, NoClass = FindDetector(FindSimililarPDBs(pdbcode,follow=False))
    if len(Class)>0:
        return order, Class
    else:
        order += 1

    Class, NoClass = FindDetector(FindSimililarPDBs(pdbcode,follow=True))
    if len(Class)>0:
        return order, Class
    else:
        return order+1, NoClass

def VMDFiler(speicherort,metal,X,HIS):
              if options.vmdfiler:
                  pathwoext=speicherort[:(len(speicherort)-4)]  
                  folder=os.path.dirname(speicherort) + "/"
                  file=os.path.basename(speicherort) 
                  filewoext=file[:(len(file)-4)]
                  savetcl = open (pathwoext+".tcl","a")
                  savesh = open (pathwoext+".sh","a")
                  sh = "# !/bin/bash\nvmd " + speicherort + " -e " + pathwoext + ".tcl" + "\n"
                  savesh.write(sh)
                  os.system("chmod +x " + pathwoext  + ".sh")
                  savesh.close()
                  tcl=""
                  #FE
                  tcl = tcl + "mol color Element\n"
                  tcl = tcl + "mol representation VDW 1.000000 13.000000\n"
                  tcl = tcl + "mol selection element " + metal.element.capitalize() + " and (x 0 and y 0 and z 0)\n"
                  tcl = tcl + "mol material Opaque\n"
                  tcl = tcl + "mol addrep 0\n"
                  #GLU
                  tcl = tcl + "mol color ColorID 1\n"
                  tcl = tcl + "mol representation Licorice 0.300000 10.000000 10.000000 \n"
                  tcl = tcl + "mol selection resname " + str(X[0].residue.name)+ " and resid " + str(X[0].residue.number) + " and chain " + X[0].residue.chain.name + "\n"
                  tcl = tcl + "mol material Opaque \n"
                  tcl = tcl + "mol addrep 0\n"
                  savetcl.write(tcl)
                  for eachhis in [HIS[0],HIS[1]]:
                      tcl= ""
                      tcl=tcl + "mol color ColorID 0\n"
                      tcl=tcl + "mol representation Licorice 0.300000 10.000000 10.000000 \n"
                      tcl=tcl + "mol selection resname " + str(eachhis.residue.name)+ " and resid " + str(eachhis.residue.number) + " and chain " + eachhis.residue.chain.name + "\n"
                      tcl=tcl + "mol material Opaque \n"
                      tcl=tcl + "mol addrep 0\n"
                      savetcl.write(tcl)
                  tcl=""
                  tcl=tcl + "mol color Element\n"
                  tcl=tcl + "mol representation NewCartoon 0.300000 6.000000 4.100000 0\n"
                  tcl=tcl + "mol selection all\n"
                  tcl=tcl + "mol material Opaque\n"
                  tcl=tcl + "mol addrep 0\n"
                  savetcl.write(tcl)
                  tcl="\n"
                  tcl=tcl + "mol modmaterial 5 0 Transparent\n"
                  #make lines invisible
                  tcl=tcl + "mol showrep 0 0 0\n"
                  tcl=tcl + "mol modstyle 0 0 CPK 0.000000 0.300000 8.000000 6.000000\n"
                  tcl=tcl + "mol color Name\n"
                  #Show close atoms in CPK
                  tcl=tcl + "mol representation CPK 0.000000 0.300000 8.000000 6.000000\n"
                  tcl=tcl + "mol selection within 10 of (x 0 and y 0 and z 0)\n"
                  tcl=tcl + "mol material Opaque\n"
                  tcl=tcl + "mol addrep 0\n"
                  tcl=tcl + "menu graphics on\n" 
                  #Show very close atoms in red
                  tcl=tcl + "mol color ColorID 28\n"
                  tcl=tcl + "mol representation VDW 0.200000 13.000000\n"
                  tcl=tcl + "mol selection within 3 of (x 0 and y 0 and z 0)\n"
                  tcl=tcl + "mol material Opaque\n"
                  tcl=tcl + "mol addrep 0\n"
                  #Center Iron into middle of screen
                  tcl=tcl + "mol showrep 0 5 0\n"
                  tcl=tcl + "display resetview\n"
                  tcl=tcl + "mol showrep 0 5 1\n"
                  savetcl.write(tcl)
                  savetcl.close()
                  os.system("echo \"./" + pathwoext+".sh" + "\" >> " + listsh)
                  os.system("chmod +x " + listsh)
                  if options.fpocketer:
                      resetdisplayview="mol top 0\nmol off 1\nmol off 2\nmol showrep 0 1 0\nmol showrep 0 2 0\nmol showrep 0 3 0\nmol showrep 0 4 0\nmol showrep 0 5 0\nmol showrep 0 6 0\nmol showrep 0 7 0\nmol showrep 0 8 0\nmol showrep 0 9 0\ndisplay resetview\nmol showrep 0 4 1\nmol showrep 0 5 1\nmol showrep 0 6 1\nmol showrep 0 7 1\nmol showrep 0 8 1\nmol showrep 0 9 1\nmol on 1\nmol on 2\nscale by 0.15\n"
                      global fpocket_results 
                      fpocket_results = pocketer(speicherort)
                      testfile = open(pathwoext + "_out/" + filewoext + ".tcl","r")
                      add=True
                      for line in testfile:
                          if "scale by 0.15" in line:
                              add=False
                              break
                      testfile.close()
                      if add:
                          os.system("cp " + pathwoext + "_out/" + filewoext + ".tcl " + pathwoext + "_out/" + filewoext + ".tcl.orig")
                          os.system("cat " + pathwoext + ".tcl >> " + pathwoext + "_out/" + filewoext + ".tcl")
                          os.system("echo \"" +resetdisplayview+ "\" >> " + pathwoext + "_out/" + filewoext + ".tcl")
              #sys.exit()

def pdistance(a,b,c):
    return float(math.sqrt(a*a+b*b+c*c))

def get_header(pqrfile):
    file = open(pqrfile, "r")
    lines=[]
    for line in file:
        if "HEADER" in line:
            lines.append(line)
    return lines

def pocket_detection(pdbfile):
    if options.progress: print "pdbfile", pdbfile 
    ppath=pdbfile[:len(pdbfile)-4] + "_out/pockets/"
    if options.progress: print "ppath:", ppath
    if not os.path.isdir(ppath):
        os.system("time fpocket -f " + pdbfile + " >> the_hunt.log")
    fileminlist=[]
    os.system("ls " + ppath + "*.pqr > " + ppath + "list.pqr.ls")
    if not os.path.exists(ppath + "pocket0_vert.pqr"):
        return [-1,"no pockets detected!", -1, -1]
    list = open (ppath + "list.pqr.ls","r")
    pocketcount=0
    for pqr in list:
        pocketcount+=1
        pqr=pqr.strip()
        file = open(pqr,"r")
        distancelist=[]
        length=0
        for line in file:
            if "HEADER" in line:
                if "Real volume" in line:
                    volume=float(line.split(":")[1])
            if "ATOM" in line:
                length+=1
                a = float(line[31:38])
                b = float(line[39:46])
                c = float(line[47:54])
                distancelist.append(pdistance(a,b,c))
        fileminlist.append([min(distancelist),pqr,length,volume])

    list.close()

    csvlistadd("pockets.count", pocketcount)
    csvlistadd("pocket.dist",min(fileminlist)[0])
    csvlistadd("pocket.globes",min(fileminlist)[2])
    csvlistadd("pocket.path",min(fileminlist)[1])
    csvlistadd("pocket.apprxvol",min(fileminlist)[3])

    return min(fileminlist)

def pocketer(pdbfile):
    #pdbfiles = list with fullpath of pdbfiles. folder must be writeable.
        results=[]
        file=pdbfile.strip()
        result=[]
        if options.progress: print "file, ", file
        t=pocket_detection(file)
        #format = distance, filename, bowls, volume
        result.append([t[0], t[1],t[2],t[3]])
        return result

def writeXYZdata(GA,rtypeX,rtype1,rtype2,atype,vx,vh1,vh2):
                if options.xyzdata:
                    xyzfilesx=xyzfiles + GA + rtypeX + atype + ".xyz"
                    xyzfilesh1=xyzfiles + GA + rtype1 + atype + ".xyz"
                    xyzfilesh2=xyzfiles + GA + rtype2 + atype + ".xyz"
                    tof  = open (xyzfilesx,"a")
                    tof.write(printVector(vx,"O"))
                    tof.close()
                    tof = open (xyzfilesh1,"a")
                    tof.write(printVector(vh1,"N"))
                    tof.close()
                    tof = open (xyzfilesh2,"a")
                    tof.write(printVector(vh2,"P"))
                    tof.close()

def RotateMoveGetRotationMatrix(X,HIS,vmetal,rotMat1,rotMat2,rotMat3):
          winkel=[]
          AREA=[]
          invert=False
          for i in [0,2,1,0]: #counting down, so that coord is coming out at the end                      
                
                # Reading data and moving metal into center (-vmetal)
                atomname=X[i].name
                
                if atomname == "CA":
                    atomname = "a"
                if atomname == "CB":
                    atomname = "b"
                if ("OE" in atomname) or ("OD" in atomname):
                    atomname = "c"
                if not atomname in ["a","b","c"]:
                    print atomname
                    print "We have a PROBLEM HERE: ATOMNAME is WRONG:"
                    print atomname
                    return 0, 0
                vx     = geom.Vec3(X[i].pos.x, X[i].pos.y, X[i].pos.z) - vmetal
                vh1    = geom.Vec3(HIS[i*2].pos.x, HIS[i*2].pos.y, HIS[i*2].pos.z) - vmetal
                vh2    = geom.Vec3(HIS[(i*2)+1].pos.x, HIS[(i*2)+1].pos.y, HIS[(i*2)+1].pos.z) - vmetal
                vx = rotMat3*(rotMat2*(rotMat1*vx))
                vh1 = rotMat3*(rotMat2*(rotMat1*vh1))
                vh2 = rotMat3*(rotMat2*(rotMat1*vh2))
               
                if options.normalize :
                    #Normalizing Vectors, if option is set AND only if its the coordinating atom.
                    vx = geom.Normalize(vx)
                    vh1 = geom.Normalize(vh1)
                    vh2 = geom.Normalize(vh2)

                atype = atomname 
                 
                if onefile:
                    rtypeX=""   
                    rtype1=""
                    rtype2=""
                else:
                    rtypeX="X."
                    rtype1="1."
                    rtype2="2."                  
                #Winkels anschreiben

                csvlistadd("atom.pos_" + atomname + ".x.x",round(vx.x,5))
                csvlistadd("atom.pos_" + atomname + ".x.y",round(vx.y,5))
                csvlistadd("atom.pos_" + atomname + ".x.z",round(vx.z,5))
                csvlistadd("atom.pos_" + atomname + ".1.x",round(vh1.x,5))
                csvlistadd("atom.pos_" + atomname + ".1.y",round(vh1.y,5))
                csvlistadd("atom.pos_" + atomname + ".1.z",round(vh1.z,5))
                csvlistadd("atom.pos_" + atomname + ".2.x",round(vh2.x,5))
                csvlistadd("atom.pos_" + atomname + ".2.y",round(vh2.y,5))
                csvlistadd("atom.pos_" + atomname + ".2.z",round(vh2.z,5))

                if atomname == "c":
                    wtot=math.degrees(geom.Angle(vx,vh1))+math.degrees(geom.Angle(vx,vh2))+math.degrees(geom.Angle(vh1,vh2))
                    csvlistadd("wtot", wtot)
                    if MINwTOT > wtot or MAXwTOT < wtot:
                        raise WtotError(wtot)


                csvlistadd("atom.angle_" + atomname + ".xm1",round(math.degrees(geom.Angle(vx,vh1))))
                csvlistadd("atom.angle_" + atomname + ".xm2",round(math.degrees(geom.Angle(vx,vh2))))
                csvlistadd("atom.angle_" + atomname + ".1m2",round(math.degrees(geom.Angle(vh1,vh2))))

                GA = X[0].residue.name
                writeXYZdata(GA,rtypeX,rtype1,rtype2,atype,vx,vh1,vh2)
                
                #Appending turned coordinates of closest atoms
                #Appending mono/bidentate information according to seebeck 2008, delta<0.15A = mono, everything else = bi
                if X[0].residue.name=="GLU":
                        O1=protein.FindAtom(X[0].residue.chain.name,X[0].residue.number,"OE1")
                        O2=protein.FindAtom(X[0].residue.chain.name,X[0].residue.number,"OE2")
                else:
                        O1=protein.FindAtom(X[0].residue.chain.name,X[0].residue.number,"OD1")
                        O2=protein.FindAtom(X[0].residue.chain.name,X[0].residue.number,"OD2")


                AREA.append(math.degrees(geom.Angle(vh2-vh1, vx-vh1))) #"w21X")
                AREA.append(math.degrees(geom.Angle(vh1-vx, vh2-vx))) #"w1X2")
                AREA.append(math.degrees(geom.Angle(vx-vh2, vh1-vh2))) #"wX21"
                AREA.append((((distance(vx, vh1))*(distance(vx, vh2)))/2)*math.sin(geom.Angle(vh2-vh1,vx-vh1))) #"Area_Coord" (a*b/2 * sin(gamma))
                
                csvlistadd("area_" + atomname, (((distance(vx, vh1))*(distance(vx, vh2)))/2)*(math.sin(geom.Angle(vh1-vx,vh2-vx))))
          
          return (O1,O2)

def csvlistadd(header, value="-1"):
    if value=="-1":
        value=header
    global headerarray
    global valuearray
    if header == value:
        headerarray.append(header)
        valuearray.append(value)
        return 1
    else:
        for x in range(0, len(headerarray)):
            if header in headerarray[x]:
                valuearray[x] = value
                return 1
        print "LOOKING FOR: ", header
        print "TO ADD: ", value
        print "def: csvlistadd"
        print csvreadlist()
        die()
        sys.exit()

def csvwritelist(csvfile):
    global valuearray
    towrite=""
    for x in range(0,len(valuearray)):
       towrite = towrite + str(valuearray[x]) + ";"
    towrite=towrite[:-1]
    towrite=towrite + "\n"
    csvfile.write(towrite)

def csvreadlist(header=""):
    global headerarray
    global valuearray
    if header == "":
        return headerarray
    for x in range(0, len(headerarray)):
        if header in headerarray[x]:
            return valuearray[x]
    return ""

def csvresetlists():
    global headerarray
    global valuearray
    headerarray=[]
    valuearray=[]

def minimalpdb(metal, path,pdbcode, X):
   path="./minimal/"
   path=path + str(csvreadlist(header="coordination_mode")) + "/"
   output=[]
   if 1==1:
    global minimalpdbcounter
    for cba in  ["c", "b", "a"]:
        for x12 in ["x","1","2"]:
            minimalpdbcounter += 1
            if x12 == "x":
                type = "O   "                    
            elif x12 == "1":
                type = "N   "                   
            else:
                type = "P   "                    

            noember="    % 3d" % int(str(metal.residue.number))
            noember=noember[-4:]
            string = "\nATOM% 7d  " % minimalpdbcounter + type +  str(metal.residue.chain.name) + str(metal.element)[0] + str(X[0].residue.name)[0] + " " + cba + noember + "      " 
            
            for xyz in ["x","y","z"]:
                    string = string + ("%+0.3f  " % float(csvreadlist(header="atom.pos_" + cba + "." + x12 + "." + xyz)))


            string = string + "1.00 22.26      " + pdbcode + " " + type[0] 
            string = string.replace("+"," ")
            output.append(string[1:])

    if not os.path.isdir(path): os.makedirs(path)

    while os.path.exists(path + csvreadlist(header="uid") + ".pdb"): 
        path = path + "d/"
        if not os.path.isdir(path):
            os.mkdir(path)
        output.append(metal)
        output.append(X[0])
        output.append(HIS[0])
        output.append(HIS[1])

    file = open (path + csvreadlist(header="uid") + ".pdb", "w")
    
    for each in output:
        file.write(str(each) + "\n")
    file.close()

def csvcreateheader(ResetLists=False):
    if ResetLists: csvresetlists()
    csvlistadd("coordination_mode")
    csvlistadd("remarks")
    csvlistadd("uid")
    csvlistadd("pdbcode")
    csvlistadd("pdbfile")
    csvlistadd("metal")
    csvlistadd("resolution")
    csvlistadd("rot.matrix")
    csvlistadd("xtype")
    csvlistadd("link2pdb")
    csvlistadd("similarpdbs")
    csvlistadd("relatedpdbs")
    csvlistadd("repetitions")
    csvlistadd("uniqueness")
    csvlistadd("AnglePlane")
    csvlistadd("cath_order")
    csvlistadd("cath_entries")
    csvlistadd("scop_order")
    csvlistadd("scop_entries")
    csvlistadd("pockets.count")
    csvlistadd("pocket.dist")
    csvlistadd("pocket.globes")
    csvlistadd("pocket.path")
    csvlistadd("pocket.apprxvol")
    csvlistadd("x.coordination.dist.O1")
    csvlistadd("x.coordination.dist.O2")
    csvlistadd("x.coordination.dist.differenz")
    csvlistadd("x.coordination.mode")

    csvlistadd("atomdetails")
    for cba in ["c", "b", "a"]:
        for x12 in ["x","1","2"]:
            for xyz in ["x","y","z"]:
                csvlistadd("atom.pos_" + cba + "." + x12 + "." + xyz)
    
    for cba in ["c", "b", "a"]:
        for p1 in [0,1,2]:
            for p2 in [0,1,2]:
                if p2 > p1:
                    p2n = str(p2)
                    p1n = str(p1)
                    if p2 == 0:
                        p2n = "x"
                    if p1 == 0:
                        p1n = "x"
                        
                    csvlistadd("atom.angle_" + cba + "." + p1n + "m" + p2n)
                    if cba=="c" and p2==2 and p1==1:
                        csvlistadd("wtot")
    for cba in ["c", "b", "a"]:
        for x12 in ["x","1","2"]:
            csvlistadd("atom.dist_" + cba + "_" + x12 + "m")
    for cba in ["c", "b", "a"]:
        csvlistadd("area_" + cba)
    csvlistadd("")
    csvlistadd("")
    csvlistadd("")
    csvlistadd("")
    csvlistadd("")
    csvlistadd("")

def join(list, delim):
    value=""
    for each in list:
        value = value + each + delim
    return value[:-1]

def csv_start(pdbcode,pdbfile,metal,aspglu,ASP,GLU,X,HIS):
        #Preparing List /i
        csvlistadd("coordination_mode", coordinationmode(X,HIS,metal))
        csvlistadd("uid",uid(pdbcode,metal,X, HIS))
        csvlistadd("pdbcode",pdbcode)
        csvlistadd("pdbfile",pdbfile.strip())
        csvlistadd("metal",metal.element)
        csvlistadd("resolution",getResolution(pdbfile))
        csvlistadd("xtype",X[0].residue.name)
        csvlistadd("link2pdb","http://www.pdb.org/pdb/explore/explore.do?structureId=" + pdbcode.upper())
        if options.scop and options.cath:
            csvlistadd("similarpdbs", join(FindSimililarPDBs(pdbcode,follow=False),","))
            csvlistadd("relatedpdbs", join(FindSimililarPDBs(pdbcode,follow=True),","))
        csvlistadd("repetitions",(str(aspglu+1) + "/" + str(len(ASP) + len(GLU))))

def uid(pdbcode,metal,X, HIS):
    element = metal.element
    if element == "ZN":
        n=1
    elif element == "FE":
        n=2
    elif element == "NI":
        n=3
    elif element == "MN":
        n=4
    elif element == "CU":
        n=5
    elif element == "CO":
        n=6
    elif element == "CD":
        n=7
    else:
        print "Improper Metal:", metal.element
        addremark("Improper Metal:"  + metal.element)
        n="X"
    return pdbcode + ":" + str(metal.residue.chain.name) + "-" +  metal.name + "-" + str(metal.residue.number) + ":" + str(X[0].residue.chain.name)[0] + "-" + str(X[0].residue.name) + "-" + str(X[0].residue.number) + ":" + str(HIS[0].residue.chain.name) + "-HIS-" + str(HIS[0].residue.number) + ":" + str(HIS[1].residue.chain.name) + "-HIS-" + str(HIS[1].residue.number)

def uid_to_atoms(uid):
    atoms=uid.split(":")
    pdbcode = atoms[0]
    metal = atoms[1].split("-")
    x     = atoms[2].split("-")
    a     = atoms[3].split("-")
    b     = atoms[4].split("-")
    print pdbcode, metal, x, a, b
    f = open ("/home/vielplatz/pdb_all/pdb" + pdbcode.lower() + ".ent", "r")
    pdbtext=[]
    for line in f:
        line = line.strip()
        if metal[1] == line[12:14] and "HETATM" == line[:7] and metal[0] == line[21] and int(line[22:26]) == int(metal[2]):
            pdbtext.append(line)
        for aa in [x,a,b]:
            if "ATOM" == line[:4] and aa[1] == line[17:20] and aa[0] == line[21] and int(line[22:26]) == int(aa[2]):
                pdbtext.append(line)
    for each in pdbtext:
        print each
    print len(pdbtext)
    if x[1]=="GLU" and len(pdbtext) != 29:
        print pdbcode
        raise Error
    if x[1]=="ASP" and len(pdbtext) != 28:
        print pdbcode
        raise Error
def coordinationmode(X,HIS,metal):
    coordination_mode=""
    if "NE" in str(HIS[1]):
        coordination_mode+="E"
    if "NE" in str(HIS[0]):
        coordination_mode+="E"
    if "ND" in str(HIS[0]):
        coordination_mode+="D"
    if "ND" in str(HIS[1]):
        coordination_mode+="D"
    if "ASP" in str(X[0]):
        coordination_mode+="A"
    if "GLU" in str(X[0]):
        coordination_mode+="G"


    if not coordination_mode in ["EDA","EDG","DDA","DDG","EEG","EEA"]:
        print "\n\n"
        print "Wrong coordination mode:", coordination_mode
        print HIS[0], HIS[1], X[0]
        print "\n\n"
        addremark("Wrong coordination mode:" + str(coordination_mode))

    return coordination_mode

def addremark(remark):
    csvlistadd("remarks",  csvreadlist("remarks") + remark)



parseoptions()

argparser()

csvcreateheader()

#PDBFiler
if options.pdbfiler:
    pathpdbfiler=os.getcwd() + "/pdbfiler/"
    if not os.path.isdir(pathpdbfiler):
        os.makedirs(pathpdbfiler)
    listsh=pathpdbfiler + "list.sh"


if options.version:
  print "Metal finder"
  print "\nVersion: ", version, "\n"
  import sys
  sys.exit()

if options.scop:
    nohit=0
    stamps=[]

    logfile = open ("dir.des.scop.txt_1.75","r")

    titlemark="-\t"
    c=0

    for line in logfile:
        if titlemark in line:
            word_list = line.split()
            letter_list = word_list[2].split(".")
            if len(letter_list)==2:
                index_name.append(word_list[2]+".")
                index_cont.append(word_list[4])

if options.verbose:
  print datei

if options.progressbar:
    openlines= open (args[0], "r")
    cntlines=0
    for each in openlines:
        cntlines +=1
    openlines.close 

# More Parameters / Initialisation ...
outputfile = open (args[1], "w")
csvwritelist(outputfile)

if datei=="":
    filelist = temp
else:
    filelist = open (datei,"r")

runde = 0
lastpdbfile=""
usedpdbfiles=[]

for pdbfile in filelist:
 if not pdbfile in usedpdbfiles:
  usedpdbfiles.append(pdbfile) 
  pdbfile=pdbfile.strip()
  lastpdbfile=pdbfile
  global similarfiles 
  similarfiles = []
  metalnr=0

  try:
    #LAZY IMPLEMENTATION
      pdbcode=pdbfile.strip()[27:31]

      if options.verbose:
        print pdbfile
      if options.progressbar:
        counter=counter+1
        print "\r %.1f" % (counter*100.0/cntlines), "% ", pdbcode,
      protein=io.LoadPDB(path + pdbfile.strip(), fault_tolerant=True)

    #FOR each ATOM in protein.atoms/
      for metal in protein.atoms:
        if isSelMetal(metal):
         othermetal=False
          #check for other metal in 10A radius
         for metal2nd in protein.atoms:
            if isMetal(metal2nd) and metal2nd != metal and distance(metal.pos, metal2nd.pos)<=4.5:
              #found another metal in 4.5A radius arround first metal => set other metal!
              if options.verbose: print "Othermetal found!"
              othermetal=True
              break
         if othermetal==False:
          metalnr=metalnr+1
          #found no other metal         
          #initialize variables ...
          if options.debugging: print "#found no other metal\n#initialize variables ..."
          atomlist=protein.FindWithin(metal.pos,maxdis)
          HEM=[]
          GLU=[]
          HIS=[]
          ASP=[]
          ELSE=[]
          smartlist=[] 
          X=[]
          
            #rewriting atom list to smartlist
          if options.debugging: print "#rewriting atom list to smartlist"
          if len(atomlist)>2:  
            c=-1
            for atom in atomlist:
              c=c+1
              x = findResInList(atom.residue,smartlist)
              if options.debugging and 0==1: print "#round", c, "replacing position", x, "atomlist_elem#:", len(atomlist), "smartlist_elem#", len(smartlist)
              if x>=0:
                if distance(smartlist[x].pos, metal.pos) > distance(atom.pos, metal.pos):
                  if options.debugging: print "#replace ", atom, " with ", smartlist[x]
                  smartlist[x]=atom
              else:
                if options.debugging: print "#append", atom 
                smartlist.append(atom)
             
            #finding shortest distance to metal of each residue
            if options.debugging: print "#finding shortest distance to metal of each residue"
            for eachatom in smartlist:
              if options.debugging: print ">>", eachatom, "<<"
              if eachatom.residue.name == "GLU":
                GLU.append(eachatom)
              elif eachatom.residue.name == "ASP":
                ASP.append(eachatom)
              elif eachatom.residue.name == "HIS":
                 HIS.append(eachatom)
              elif eachatom.residue.name == "HEM":
                 HEM.append(eachatom)
                 break
              elif eachatom == metal:
                 if 3==1: print "metal in metallist"
              else:
                ELSE.append(eachatom)
            #    
            
            #setting X to GLU OR ASP, if GLU OR ASP != 0
            if options.debugging: print "#setting X to GLU OR ASP, if GLU OR ASP != 0"
            if len(HEM)==0 and len(HIS)==2:


    # PREPARING writing OF THE RESULTS
             
             for aspglu in range(0,len(ASP)+len(GLU)):
              csvcreateheader(True)
              X=[]
              if aspglu<len(ASP): 
               X.append(ASP[aspglu])
              else:
               X.append(GLU[aspglu-len(ASP)])
              if 1==0:
               print "  ASPGLU: ", aspglu
               print "  len ASP: ", len(ASP), " GLU: ", len(GLU)
               for each in ASP:
                   print each
               for each in GLU:
                   print each

	          #Compairing Angles between X and H0/H1. The smaller Angle has to be from H0. 
              if math.degrees(geom.Angle(X[0].pos-metal.pos, HIS[0].pos-metal.pos)) > math.degrees(geom.Angle(X[0].pos-metal.pos, HIS[1].pos-metal.pos)):
                #The angle is larger, so changing the values ...
                temp=HIS[0]
                HIS[0]=HIS[1]
                HIS[1]=temp
              csv_start(pdbcode,pdbfile,metal,aspglu,ASP,GLU,X,HIS)
              
              if not csvreadlist(header="uid") in uuidlist:
                  uuidlist.append(csvreadlist(header="uid") )
              else:
                  print "we have a problem!"
                  print lastfile
                  print pdbfile
                  print "i should add:", csvreadlist(header="uid"), "to list"
                  print "but the list is:", uuidlist
                  die()

                
        #X exists going to find CA and CB from X, H1 and H2
              if options.debugging: print "#X exists going to find CA and CB from X, H1 and H2"
              for AB in ["CA", "CB"]:
                X.append(protein.FindAtom(X[0].residue.chain.name,X[0].residue.number,AB))
                for H in [0,1]:
                  HIS.append(protein.FindAtom(HIS[H].residue.chain.name,HIS[H].residue.number,AB))
            
             
              # Introducing 4 Vectors: vmetal, vx, vh1, vh2
              vmetal = geom.Vec3(metal.pos.x, metal.pos.y, metal.pos.z)
              vx     = geom.Vec3(X[0].pos)
              vh1    = geom.Vec3(HIS[0].pos)
              vh2    = geom.Vec3(HIS[1].pos)
              
              # Moving the metal into the root of the coordination centre:
              vx     = vx - vmetal
              vh1    = vh1 - vmetal
              vh2    = vh2 - vmetal      
              vP     = vh1 + vh2
              angleP = round(math.degrees(geom.Angle(vP,vx)),2)
              csvlistadd(str(angleP))                    
             
              # Determining the Rotation matrix ...
              rotMat1, rotMat2, rotMat3 = winkler(vx,vh1)
              # Apply the rotation matrizes on each point:
              vx = rotMat3*(rotMat2*(rotMat1*vx))
              vh1 = rotMat3*(rotMat2*(rotMat1*vh1))
              vh2 = rotMat3*(rotMat2*(rotMat1*vh2))
              # Preparing the xyz output file ...
              xyzfiles=args[1] + "." + str(metal.element) + "."



              rotMatUnif=rotMat3*rotMat2*rotMat1

              csvlistadd("rot.matrix",rotMatUnif)
              # Apply rotation matrizes on Ca, Cb and Cclosest of each HIS and GLU/ASP
              
              if options.pdbfiler:
                  protcopy = protein.Copy()
                  editor = protcopy.RequestXCSEditor()
                  editor.ApplyTransform(geom.Mat4(1,0,0,-vmetal.x,0,1,0,-vmetal.y,0,0,1,-vmetal.z,0,0,0,1))
                  Mat4=geom.Mat4(rotMatUnif)
                  editor.ApplyTransform(Mat4)
                  if HIS[1].pos.y < 0:
                      editor.ApplyTransform(geom.Mat4(1,0,0,0,0,-1,0,0,0,0,1,0,0,0,0,1))
                  fn=os.path.basename(pdbfile)
                  if options.progressbar: print "fn",fn
                  pfad = args[1]    + "rot/" + metal.element + "/" + X[0].residue.name + "/"
                  if os.path.exists(pfad)==False:
                    print "made dir:", os.makedirs(pfad)
                  fns = fn.split(".")
    #TRAP BUG: if more than 100 valid metals in one => overwriting 
                  speicherort = pathpdbfiler  + fns[0][3:] + "_" + metal.element + str(metal.residue.number) +  metal.residue.chain.name + "_" +  str(X[0].residue.name)  + str(X[0].residue.number) + ".pdb"
                  while os.path.isfile(speicherort):
                      os.system("rm " + speicherort)
                  if options.verbose:
                      print "Saving File to > ", speicherort
                  io.SavePDB(protcopy, speicherort)
                  
                  VMDFiler(speicherort,metal,X,HIS)                                          

              try:
                  (O1,O2)  =  RotateMoveGetRotationMatrix(X,HIS,vmetal,rotMat1,rotMat2,rotMat3)
              except WtotError as Message:
                print "WTOT is not in range. Cancel File", pdbfile.strip()
                print Message
                os.system("echo \"" + str(Message) + " " + pdbfile.strip() + "\" >> WtotError.LOG")
                O1=0

              if O1 != 0:

    # END OF PREPARING OUTPUT/
                  d1=distance(O1.pos, metal.pos)
                  d2=distance(O2.pos, metal.pos)
                  differenz = d1-d2
                  csvlistadd("x.coordination.dist.O1", distance(O1.pos, metal.pos))
                  csvlistadd("x.coordination.dist.O2", distance(O2.pos, metal.pos)) 
                  csvlistadd("x.coordination.dist.differenz", differenz)
                
                  if abs(differenz) >= 0.15:
                        csvlistadd("x.coordination.mode", "mono")
                  else:
                        csvlistadd("x.coordination.mode", "bi")

                  chains=[]
                  chains.append(X[0].residue.chain.name)
                  chains.append(HIS[0].residue.chain.name)
                  chains.append(HIS[1].residue.chain.name)
                  chains.append(metal.residue.chain.name)
                  if options.verbose: print chains
                  chain=[]
                  for each in chains:
                      if not each in chain:
                          chain.append(each)

                  chains=chain
              
    #C A T H F I L E R _ _ E X T E N S I O N:
                  if options.cathfiler:
                      (corder, cathres)=cathfiler(pdbcode)
                      cathappend=[]
                      if verbose: print cathres
                      for each in cathres:
                          if each[1] in chains:
                              cathappend.append(str(each))
                  
                      if cathappend==[]:
                          cathappend=str(cathres)
                          csvlistadd("cath_order",corder + 10) 
                      else: 
                          csvlistadd("cath_order",str(corder))
                      
                      csvlistadd("cath_entries",str(cathappend))

    #S C O P F I L E R _ _ E X T E N S I O N:
                  if options.scop:
                      (sorder, scopres)=scopfiler(pdbcode)
                      scopappend=[]
                      if verbose: print scopres
                      if len(scopres)>0: 
                       for res in scopres:
                        for each in res:
                          if len(each) > 0 and each[0] in chains:
                              scopappend.append(str(each))
                  
                      if len(scopappend)==0:
                          scopappend=str(scopres)
                          csvlistadd("scop_order", sorder + 10)
                      else:
                          csvlistadd("scop_order", str(sorder))
            
                      csvlistadd("scop_entries", str(scopappend))
                      scopres=[]
                      sorder=-1
            
                  #minimalpdb(metal, path,pdbcode, X)
                      
                  csvwritelist(outputfile)
              
                  if options.progress:
                       print "\n\n", round((counter*100.0/cntlines),2), "%\n\n"
                  
                  if nodoublehits:
                      raise GotHitError(1)

  except UserWarning:
    print "UserWarning: SOMETHING WENT WRONG!"
    print "ADD INFORMATION TO WARNING.LOG"
    os.system("echo \"UserWarning " + pdbfile.strip() +"\" >> WARNING.LOG")
  except GotHitError:
    print "Have a hit, canceling scan of file", pdbfile
#  except:
#    print "ERROR!"
#    print "ADD INFORMATION TO ERR.LOG"
#    os.system("echo \"ERROR " + pdbfile.strip() +"\" >> ERR.LOG")
   #END FOR EACH ATOM IN PROTEIN/



#END OF MAIN /

if len(SKIPPED)!=0:
  print "WARNING: SKIPPED SCAN OF THE FOLLOWING FILES:"
  for each in SKIPPED:
    print each

if options.xyzdata:
  # determine outputfolder:
  outputfolder=os.path.dirname(os.path.abspath(args[1]))
  # create temporary folder tmp in outputfolder
  # moving into outputfolder, then add the first line with everything needed in it. 
  # Move everithiny from ./tmp folder to ./..
  # Remove tmp
  os.system("cd " + outputfolder + "; mkdir tmp; for i in *.xyz; do wc -l $i | awk '{print ($1)}' > ./tmp/$i; echo >> ./tmp/$i; cat $i >> ./tmp/$i; done; cd tmp; mv * ..;cd ..;rmdir tmp")

outputfile.close()
if not datei=="":
    filelist.close()


os.system("echo \"FINISHED \" >> FINISH.LOG")
